/*
 * OutOfRangeException class.
 *
 * Copyright (C) 2007 SATOH Takayuki All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
package ts.util;

/**
 * あるデータの値が範囲外になったときにスローされる例外クラス。
 * <br>
 * フィールド変数には、そのときのデータの値と、そのデータのとるべき範囲の
 * 開始値、終了値を持っている。
 *
 * @author  佐藤隆之. 
 * @version $Revision: 1.1.1.1 $, $Date: 2010-10-16 00:03:44 $
 */
public class OutOfRangeException extends RuntimeException
{
  /** シリアル番号。 */
  static final long serialVersionUID = -927835090593432651L;

  /** 範囲外になったときの値。 */
  private Comparable value_;

  /** 範囲の開始値。 */
  private Comparable start_;

  /** 範囲の終了値。*/
  private Comparable end_;

  /**
   * 範囲外になった<code>int</code>値と、<code>int</code>型の範囲を
   * 引数にとるコンストラクタ。
   *
   * @param  value 範囲外になった値。
   * @param  start 範囲の開始値。
   * @param  end   範囲の終了値。
   */
  public OutOfRangeException(int value, int start, int end)
  {
    value_ = new Integer(value);

    if (start < end) {
      start_ = new Integer(start);
      end_   = new Integer(end);
    }
    else {
      start_ = new Integer(end);
      end_   = new Integer(start);
    }
  }

  /**
   * 範囲外になった<code>long</code>値と、<code>long</code>型の範囲を
   * 引数にとるコンストラクタ。
   *
   * @param  value 範囲外になった値。
   * @param  start 範囲の開始値。
   * @param  end   範囲の終了値。
   */
  public OutOfRangeException(long value, long start, long end)
  {
    value_ = new Long(value);

    if (start < end) {
      start_ = new Long(start);
      end_   = new Long(end);
    }
    else {
      start_ = new Long(end);
      end_   = new Long(start);
    }
  }

  /**
   * 範囲外になった<code>float</code>値と、<code>float</code>型の範囲を
   * 引数にとるコンストラクタ。
   *
   * @param  value 範囲外になった値。
   * @param  start 範囲の開始値。
   * @param  end   範囲の終了値。
   */
  public OutOfRangeException(float value, float start, float end)
  {
    value_ = new Float(value);

    if (start < end) {
      start_ = new Float(start);
      end_   = new Float(end);
    }
    else {
      start_ = new Float(end);
      end_   = new Float(start);
    }
  }

  /**
   * 範囲外になった<code>double</code>値と、<code>double</code>型の範囲を
   * 引数にとるコンストラクタ。
   *
   * @param  value 範囲外になった値。
   * @param  start 範囲の開始値。
   * @param  end   範囲の終了値。
   */
  public OutOfRangeException(double value, double start, double end)
  {
    value_ = new Double(value);

    if (start < end) {
      start_ = new Double(start);
      end_   = new Double(end);
    }
    else {
      start_ = new Double(end);
      end_   = new Double(start);
    }
  }

  /**
   * 範囲外になった{@link java.lang.Comparable Comparable}オブジェクトと、
   * {@link java.lang.Comparable Comparable}オブジェクトの範囲を引数にとる
   * コンストラクタ。
   * <br>
   * 引数にヌルを指定した場合は、そのままヌルを設定する。
   *
   * @param  value 範囲外になった値。
   * @param  start 範囲の開始値。
   * @param  end   範囲の終了値。
   */
  public <U extends Comparable<U>> OutOfRangeException(U value, U start, U end)
  {
    if (start == null || end == null) {
      value_ = value;
      start_ = start;
      end_ = end;
    }
    else if (start.compareTo(end) < 0) {
      value_ = value;
      start_ = start;
      end_ = end;
    }
    else {
      value_ = value;
      start_ = end;
      end_ = start;
    }
  }

  /**
   * メッセージを引数にとるコンストラクタ。
   * <br>
   * 範囲外になった値及び範囲の開始値、終了値には、それぞれヌルを設定する。
   * 引数にヌルを指定された場合は、メッセージにそのままヌルを設定する。
   * 
   * @param  msg 例外メッセージ。
   */
  public OutOfRangeException(String msg)
  {
    super(msg);
  }

  /**
   * 範囲外となった値を表す数値オブジェクトを返す。
   *
   * @return 範囲外となった値の数値オブジェクト。
   */
  public Comparable getValue()
  {
    return value_;
  }

  /**
   * 範囲の開始値を表す数値オブジェクトを返す。
   *
   * @return 範囲の開始値の数値オブジェクト。
   */
  public Comparable getStart()
  {
    return start_;
  }

  /**
   * 範囲の終了値を表す数値オブジェクトを返す。
   *
   * @return 範囲の終了値の数値オブジェクト。
   */
  public Comparable getEnd()
  {
    return end_;
  }

  /**
   * 例外メッセージを取得する。
   * <br>
   * 範囲外となった値、範囲の開始値、終了値のいずれかがヌルでない場合は、
   * それらの値を表示するメッセージを返す。
   * それらのすべての値がヌルの場合は、コンストラクタで設定されたメッセージが
   * あればそれを返し、それもヌルであればヌルを返す。
   *
   * @return 例外メッセージ。
   */
  public String getMessage()
  {
    if (value_ != null || start_ != null || end_ != null) {
      StringBuilder msg = new StringBuilder();
      msg.append((value_ != null) ? value_.toString() : "?");
      msg.append(" is out of range (");
      msg.append((start_ != null) ? start_.toString() : "-");
      msg.append(",");
      msg.append((end_ != null) ? end_.toString() : "-");
      msg.append(").");
      return msg.toString();
    }

    return super.getMessage();
  }
}
